MPQC 2.3.1

- Main Page
- Related Pages
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Friends | List of all members
sc::BlockedDiagSCMatrix Class Reference
Inheritance diagram for sc::BlockedDiagSCMatrix:
[legend]
Collaboration diagram for sc::BlockedDiagSCMatrix:
[legend]

## Public Member Functions
| BlockedDiagSCMatrix (const RefSCDimension &, BlockedSCMatrixKit *)
void | save (StateOut &)
| Save and restore this in an implementation independent way.
void | restore (StateIn &)
double | get_element (int) const
| Return or modify an element.
void | set_element (int, double)
void | accumulate_element (int, double)
void | accumulate (const DiagSCMatrix *)
| Sum m into this.
double | invert_this ()
| Invert this.
double | determ_this ()
| Return the determinant of this. this is overwritten.
double | trace ()
| Return the trace.
void | gen_invert_this ()
| Do a generalized inversion of this.
void | element_op (const Ref< SCElementOp > &)
| Perform the element operation op on each element of this.
void | element_op (const Ref< SCElementOp2 > &, DiagSCMatrix *)
void | element_op (const Ref< SCElementOp3 > &, DiagSCMatrix *, DiagSCMatrix *)
void | vprint (const char *title=0, std::ostream &out=ExEnv::out0(), int=10) const
RefSCDimension | dim () const
RefSCDimension | dim (int) const
int | nblocks () const
RefDiagSCMatrix | block (int)
Ref< SCMatrixSubblockIter > | local_blocks (SCMatrixSubblockIter::Access)
| Returns iterators for the local (rapidly accessible) blocks used in this matrix. More...
Ref< SCMatrixSubblockIter > | all_blocks (SCMatrixSubblockIter::Access)
| Returns iterators for the all blocks used in this matrix.
Public Member Functions inherited from sc::DiagSCMatrix
| DiagSCMatrix (const RefSCDimension &, SCMatrixKit *)
Ref< SCMatrixKit > | kit () const
| Return the SCMatrixKit used to create this object.
virtual double | maxabs () const
| Return the maximum absolute value element of this vector.
virtual void | randomize ()
| Assign each element to a random number between -1 and 1.
void | assign (double val)
| Set all elements to val.
void | assign (const double *p)
| Assign element i, i to m[i].
void | assign (DiagSCMatrix *d_a)
| Make this have the same elements as m. More...
virtual void | assign_val (double val)
| Overridden to implement the assign members.
virtual void | assign_p (const double *)
virtual void | assign_d (DiagSCMatrix *)
virtual void | convert (double *) const
| Like the assign member, but this writes values to the argument.
virtual void | convert (DiagSCMatrix *)
| Convert an SCDiagSCMatrix of a different specialization to this specialization and possibly accumulate the data. More...
virtual void | convert_accumulate (DiagSCMatrix *)
virtual void | scale (double)
| Multiply all elements by val.
int | n () const
| Return the dimension.
virtual DiagSCMatrix * | copy ()
| Return a matrix with the same dimension and same elements.
virtual DiagSCMatrix * | clone ()
| Return a matrix with the same dimension but uninitialized memory.
RefSCDimension | dim () const
| Return the dimension.
void | print (std::ostream &o=ExEnv::out0()) const
| Print out the matrix.
void | print (const char *title=0, std::ostream &out=ExEnv::out0(), int=10) const
Ref< MessageGrp > | messagegrp () const
| Returns the message group used by the matrix kit.
Public Member Functions inherited from sc::DescribedClass
| DescribedClass (const DescribedClass &)
DescribedClass & | operator= (const DescribedClass &)
ClassDesc * | class_desc () const throw ()
| This returns the unique pointer to the ClassDesc corresponding to the given type_info object. More...
const char * | class_name () const
| Return the name of the object's exact type.
int | class_version () const
| Return the version of the class.
Public Member Functions inherited from sc::RefCount
int | lock_ptr () const
| Lock this object.
int | unlock_ptr () const
| Unlock this object.
void | use_locks (bool inVal)
| start and stop using locks on this object
refcount_t | nreference () const
| Return the reference count.
refcount_t | reference ()
| Increment the reference count and return the new count.
refcount_t | dereference ()
| Decrement the reference count and return the new count.
int | managed () const
void | unmanage ()
| Turn off the reference counting mechanism for this object. More...
int | managed () const
| Return 1 if the object is managed. Otherwise return 0.
Public Member Functions inherited from sc::Identity
Identifier | identifier ()
| Return the Identifier for this argument. More...

## Friends
class | BlockedSCMatrix
class | BlockedSymmSCMatrix
class | BlockedSCVector

## Additional Inherited Members
Protected Member Functions inherited from sc::RefCount
| RefCount (const RefCount &)
RefCount & | operator= (const RefCount &)
Protected Attributes inherited from sc::DiagSCMatrix
RefSCDimension | d
Ref< SCMatrixKit > | kit_

## Member Function Documentation

Ref<SCMatrixSubblockIter> sc::BlockedDiagSCMatrix::local_blocks | ( | SCMatrixSubblockIter::Access |  | ) |
| virtual

Returns iterators for the local (rapidly accessible) blocks used in this matrix.

Implements sc::DiagSCMatrix.

The documentation for this class was generated from the following file:

- blocked.h